'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = listPage;

var _handlebars = require('handlebars');

var _handlebars2 = _interopRequireDefault(_handlebars);

var _math = require('../utils/math');

var _math2 = _interopRequireDefault(_math);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _ = require('../../');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function listPage(file, workflow, index, action, text) {
  var resWorkflow = '';
  var res = _.Hooks.instance.trigger('beforeListPage', file, workflow, index, action, text);
  res += '<tr>';
  res += '<td>' + (0, _math2.default)(index, '+', 1) + '</td>\n        <td>\n          <a href="/abe/' + file.template + '?filePath=' + file.path + '" class="file-path">\n            ' + file.path + '\n          </a>\n        </td>';

  if (file.date) {
    res += '<td align="center">\n              ' + (0, _moment2.default)(file.date).format('YYYY-MM-DD') + '\n            </td>';
  }

  var checkFlow = false;
  for (var prop in workflow) {
    var flow = workflow[prop];
    if (flow !== false) checkFlow = true;
    resWorkflow += '<td align="center">';

    if (flow.filePath && flow.latest) {
      resWorkflow += '<a href="/abe/' + file.template + '?filePath=' + file.path + '" class="label label-default label-workflow">' + prop + '</a>';
    }
    resWorkflow += '</td>';
  }

  res += '<td align="center">';
  if (typeof file.draft !== 'undefined' && file.draft !== null) {
    if (!checkFlow && (!file.published || file.published.abe_meta.date !== file.draft.abe_meta.latest.date)) {
      res += '<a href="/abe/{{this.template}}?filePath={{this.draft.cleanFilePath}}" class="label label-default label-draft">';
      res += file.draft.abe_meta.complete === 100 ? 'draft' : file.draft.abe_meta.complete + '%';
      res += '</a>';
    }
  }

  res += '</td>\n          ' + resWorkflow + '\n          <td align="center">';

  if (file.published) {
    res += '<a href="/abe/' + file.template + '?filePath=' + file.published.filePath + '" class="checkmark">&#10004;</a>';
  }
  res += '</td>\n          <td align="center">\n            <div class="row icons-action">\n              <div class="col-xs-6">';

  if (this.published) {
    if (action.unpublish) {
      res += '<a href="/unpublish/?filePath=' + file.path + '"\n                 title="' + text.unpublish + '"\n                 class="icon" data-unpublish="true"data-text="' + text.confirmUnpublish + ' {{file.path}}">\n                <span class="glyphicon glyphicon-eye-close"></span>\n              </a>';
    }
  }

  res += '</div>\n          <div class="col-xs-6">';

  if (action.delete) {
    res += '<a href="/delete/?filePath=' + this.path + '"\n               title="' + text.delete + '"\n               class="icon"\n               data-delete="true"\n               data-text="' + text.confirmDelete + ' ' + file.path + '">\n              <span class="glyphicon glyphicon-trash"></span>\n            </a>';
  }

  res += '</div>\n        </div>\n      </td>\n    </tr>';

  var res = _.Hooks.instance.trigger('afterListPage', res, file, workflow, index, action, text);

  return new _handlebars2.default.SafeString(res);
}