'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _dirCompare = require('dir-compare');

var _dirCompare2 = _interopRequireDefault(_dirCompare);

var _mkdirp = require('mkdirp');

var _mkdirp2 = _interopRequireDefault(_mkdirp);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _ = require('../');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var FileUtils = function () {
	function FileUtils() {
		_classCallCheck(this, FileUtils);
	}

	_createClass(FileUtils, null, [{
		key: 'pathWithRoot',
		value: function pathWithRoot(path) {
			if (typeof path === 'undefined' || path === null || path === '') path = '';
			return FileUtils.concatPath(_.config.root, path.replace(_.config.root, '')).replace(/\/$/, "");
		}
	}, {
		key: 'cleanPath',
		value: function cleanPath(path) {
			if (typeof path !== 'undefined' && path !== null) path = path.replace(/\/$/, "");
			return path;
		}
	}, {
		key: 'concatPath',
		value: function concatPath() {
			var path = '';
			Array.prototype.forEach.call([].slice.call(arguments), function (argument) {
				if (path !== '') argument = argument.replace(/^\//, "");
				if (argument !== '') path += FileUtils.cleanPath(argument) + '/';
			});

			path = FileUtils.cleanPath(path);

			return path;
		}
	}, {
		key: 'removeLast',
		value: function removeLast(path) {
			return path.substring(0, FileUtils.cleanPath(path).lastIndexOf('/'));
		}
	}, {
		key: 'replaceExtension',
		value: function replaceExtension(path, ext) {
			return path.substring(0, path.lastIndexOf('.')) + '.' + ext;
		}
	}, {
		key: 'removeExtension',
		value: function removeExtension(path) {
			return path.substring(0, path.lastIndexOf('.'));
		}
	}, {
		key: 'filename',
		value: function filename(path) {
			return FileUtils.cleanPath(path).substring(FileUtils.cleanPath(path).lastIndexOf('/') + 1);
		}
	}, {
		key: 'isFile',
		value: function isFile(path) {
			try {
				var stat = _fsExtra2.default.statSync(path);
				return true;
			} catch (e) {
				return false;
			}
			return false;
		}
	}, {
		key: 'isValidFile',
		value: function isValidFile(fileName) {
			var dotPosition = fileName.indexOf('.');
			if (dotPosition > 0) return true;
			return false;
		}
	}, {
		key: 'cleanTplName',
		value: function cleanTplName(path) {
			var cleanTplName = _.fileAttr.delete(path);
			cleanTplName = cleanTplName.replace(_.config.root, '');
			cleanTplName = cleanTplName.split('/');
			cleanTplName.shift();
			return cleanTplName.join('/');
		}
	}, {
		key: 'cleanFilePath',
		value: function cleanFilePath(path) {
			var cleanFilePath = _.fileAttr.delete(path);
			cleanFilePath = cleanFilePath.replace(_.config.root, '');
			cleanFilePath = cleanFilePath.split('/');
			cleanFilePath.shift();
			return cleanFilePath.join('/');
		}
	}, {
		key: 'getFilePath',
		value: function getFilePath(path) {
			var res = null;
			if (typeof path !== 'undefined' && path !== null && path !== '') {
				res = path.replace(_.config.root);
				res = FileUtils.concatPath(_.config.root, _.config.draft.url, res);
			}
			return res;
		}
	}, {
		key: 'getTemplatePath',
		value: function getTemplatePath(path) {
			var res = null;
			if (typeof path !== 'undefined' && path !== null && path !== '') {
				res = path.replace(_.config.root);
				res = FileUtils.concatPath(_.config.root, _.config.templates.url, res);
			}
			return res;
		}
	}, {
		key: 'deleteOlderRevisionByType',
		value: function deleteOlderRevisionByType(fileName, type) {
			var folder = fileName.split('/');
			var file = folder.pop();
			var extension = file.replace(/.*?\./, '');
			folder = folder.join('/');
			var stat = _fsExtra2.default.statSync(folder);
			if (stat) {
				var files = _.FileParser.getFiles(folder, true, 1, new RegExp("\\." + extension));
				files.forEach(function (fileItem) {
					var fname = _.fileAttr.delete(fileItem.cleanPath);
					var ftype = _.fileAttr.get(fileItem.cleanPath).s;
					if (fname === file && ftype === type) {
						var fileDraft = fileItem.path.replace(/-abe-./, '-abe-d');
						_.FileParser.removeFile(fileItem.path, _.FileParser.changePathEnv(fileItem.path, _.config.data.url).replace(new RegExp("\\." + extension), '.json'));
						_.FileParser.removeFile(fileDraft, _.FileParser.changePathEnv(fileDraft, _.config.data.url).replace(new RegExp("\\." + extension), '.json'));
					}
				});
			}
		}
	}, {
		key: 'checkMergedFile',
		value: function checkMergedFile(file, merged) {
			var cleanFilePath = file.cleanFilePath;
			var revision = {
				status: file.status,
				filePath: file.filePath,
				date: file.abe_meta.latest.date,
				template: file[_.config.meta.name].template,
				cleanFilePath: cleanFilePath
			};
			revision[_.config.meta.name] = file[_.config.meta.name];

			if (typeof merged[cleanFilePath] === 'undefined' || merged[cleanFilePath] === null) {
				merged[cleanFilePath] = {};

				merged[cleanFilePath].cleanFilePath = revision.cleanFilePath;
				merged[cleanFilePath].date = revision.date;
				merged[cleanFilePath].template = revision.template;
				merged[cleanFilePath][_.config.meta.name] = revision[_.config.meta.name];
				merged[cleanFilePath][file.status] = revision;
			} else {
				var oldDate = new Date(merged[cleanFilePath].date);
				var newDate = new Date(revision.date);
				var oldStatus = '';
				if (typeof merged[cleanFilePath][revision.status] !== 'undefined' && merged[cleanFilePath][revision.status] !== null) {
					oldStatus = merged[cleanFilePath][revision.status].status;
				}
				var newStatus = revision.status;

				// if draft > publish
				if (typeof merged[cleanFilePath][newStatus] === 'undefined' || merged[cleanFilePath][newStatus] === null) {
					merged[cleanFilePath][newStatus] = revision;
				} else if (newDate > oldDate && oldStatus === newStatus) {
					merged[cleanFilePath][file.status] = revision;
				}
			}
		}
	}, {
		key: 'mergeFiles',
		value: function mergeFiles(files1, files2) {
			var merged = {};
			var arMerged = [];

			Array.prototype.forEach.call(files1, function (file) {
				FileUtils.checkMergedFile(file, merged);
			});

			Array.prototype.forEach.call(files2, function (file) {
				FileUtils.checkMergedFile(file, merged);
			});

			Array.prototype.forEach.call(Object.keys(merged), function (key) {
				var merge = merged[key];
				var publishedDate = typeof merge.published !== 'undefined' && merge.published !== null ? new Date(merge.published.date) : null;
				var draftDate = typeof merge.draft !== 'undefined' && merge.draft !== null ? new Date(merge.draft.date) : null;

				if (publishedDate !== null && draftDate !== null && publishedDate >= draftDate) {
					merge.draft = null;
				}
				var revision = {
					path: merge.cleanFilePath,
					template: merge.template,
					published: merge.published,
					date: merge.date,
					draft: merge.draft
				};
				arMerged.push(revision);
			});

			return arMerged;
		}
	}]);

	return FileUtils;
}();

exports.default = FileUtils;