import Handlebars from 'handlebars'
import fse from 'fs-extra'

import {
  Plugins
  ,fileUtils
  ,config
} from '../../'


export default function abeImport (file, config, ctx) {
  var config = JSON.parse(config)
  var defaultPartials = `${__dirname.replace(/\/$/,"")}/${config.defaultPartials.replace(/\/$/,"")}`
  var partials = (config.partials !== '') ? `${config.root.replace(/\/$/,"")}/${config.partials.replace(/\/$/,"")}` : defaultPartials
  var pathToPartial = `${partials}/${file}.html`
  try{
    var stat = fse.statSync(pathToPartial)
  }
  catch(e){
    var pathToPartial = `${defaultPartials}/${file}.html`
  }
  var html = fse.readFileSync(pathToPartial, 'utf8')

  var pluginsPartials = Plugins.instance.getPartials()
  Array.prototype.forEach.call(pluginsPartials, (pluginPartials) => {
    var checkFile = fileUtils.concatPath(pluginPartials, `${file}.html`)
    if (fileUtils.isFile(checkFile)) {
      html += fse.readFileSync(checkFile, 'utf8')
    }
  })
  var template = Handlebars.compile(html)

  return new Handlebars.SafeString(template(ctx))
}
