import Handlebars from 'handlebars'
import math from '../utils/math'
import moment from 'moment'
import {Hooks} from '../../'

export default function listPage(file, workflow, index, action, text) {
  var resWorkflow = ''
  var res = Hooks.instance.trigger('beforeListPage', file, workflow, index, action, text)
  res += `<tr>`
  res += `<td>${math(index, '+', 1)}</td>
        <td>
          <a href="/abe/${file.template}?filePath=${file.path}" class="file-path">
            ${file.path}
          </a>
        </td>`
  
  if(file.date){
    res += `<td align="center">
              ${moment(file.date).format('YYYY-MM-DD')}
            </td>`
  }

  var checkFlow = false
  for(var prop in workflow){
    var flow = workflow[prop]
    if(flow !== false) checkFlow = true
    resWorkflow += `<td align="center">`

    if (flow.filePath && flow.latest){
      resWorkflow += `<a href="/abe/${file.template}?filePath=${file.path}" class="label label-default label-workflow">${prop}</a>`
    }
    resWorkflow += `</td>`
  }

  res += `<td align="center">`
  if(typeof file.draft !== 'undefined' && file.draft !== null) {
    if(!checkFlow && (!file.published || (file.published.abe_meta.date !== file.draft.abe_meta.latest.date))){
      res += `<a href="/abe/{{this.template}}?filePath={{this.draft.cleanFilePath}}" class="label label-default label-draft">`
      res += (file.draft.abe_meta.complete === 100) ? `draft` : `${file.draft.abe_meta.complete}%`
      res += `</a>`
    }
  }

  res += `</td>
          ${resWorkflow}
          <td align="center">`

  if (file.published){
    res += `<a href="/abe/${file.template}?filePath=${file.published.filePath}" class="checkmark">&#10004;</a>`
  }
  res += `</td>
          <td align="center">
            <div class="row icons-action">
              <div class="col-xs-6">`
  
  if (this.published){
    if (action.unpublish){
      res += `<a href="/unpublish/?filePath=${file.path}"
                 title="${text.unpublish}"
                 class="icon" data-unpublish="true"data-text="${text.confirmUnpublish} {{file.path}}">
                <span class="glyphicon glyphicon-eye-close"></span>
              </a>`
    }
  }

          
  res += `</div>
          <div class="col-xs-6">`
      
  if(action.delete){
    res += `<a href="/delete/?filePath=${this.path}"
               title="${text.delete}"
               class="icon"
               data-delete="true"
               data-text="${text.confirmDelete} ${file.path}">
              <span class="glyphicon glyphicon-trash"></span>
            </a>`
  }

  res += `</div>
        </div>
      </td>
    </tr>`

  var res = Hooks.instance.trigger('afterListPage', res, file, workflow, index, action, text)

  return new Handlebars.SafeString(res)
}
